<template>
  <div class="dropdown">
    <i
      class="fa fa-user fa-2x fa-fw dropdown-toggle"
      :class="isImpersonating ? 'ghost' : ''"
      data-toggle="dropdown"
      aria-haspopup="true"
      aria-expanded="true"
    >
      <span class="caret" /></i>
    <ul
      class="dropdown-menu"
      aria-labelledby="dropdownMenu1"
    >
      <li v-if="user!=null && isOn===false && user.canAccessData && !isManager">
        <router-link
          class="navbar-item"
          :to="{ path: '/tableau-de-bord'}"
        >
          <pie-icon /><span style="color: #e65245;">Tableau de bord</span>
        </router-link>
      </li>
      <li v-if="isAdmin">
        <router-link
          class="navbar-item"
          :to="{ path: '/admin/accueil'}"
        >
          <home-icon /><span>Accueil</span>
        </router-link>
      </li>
      <li v-if="user!=null && isOn===false">
        <router-link
          class="navbar-item"
          :to="{ path: '/compte-utilisateur'}"
        >
          <user-icon /><span>Compte utilisateur</span>
        </router-link>
      </li>
      <li v-if="(user!=null && user.canUploadDsnFile) && isOn===false && !isManager">
        <router-link
          class="navbar-item"
          :to="{ path: '/fichiers-dsn'}"
        >
          <upload-icon /><span>Ajouter un fichier DSN</span>
        </router-link>
      </li>
      <li v-if="user!=null && isBusiness && isOn===false && !isManager">
        <router-link
          class="navbar-item"
          :to="{ path: '/sirens'}"
        >
          <siren-icon /><span>Gérer les entreprises</span>
        </router-link>
      </li>
      <li v-if="(user!=null && user.canCreateUser) && isOn===false && !isManager">
        <router-link
          class="navbar-item"
          :to="{ path: '/utilisateurs'}"
        >
          <users-icon /><span>Gérer les utilisateurs</span>
        </router-link>
      </li>
      <li v-if="user!=null && isBusiness && isOn===false && !isManager">
        <router-link
          class="navbar-item"
          :to="{ path: '/groupements'}"
        >
          <group-icon /><span>Groupement d’entreprises</span>
        </router-link>
      </li>
      <!-- START MANAGER ONLY -->
      <li v-if="user!=null && isManager">
        <router-link
          class="navbar-item"
          :to="{ path: '/gestionnaire/equipes'}"
        >
          <users-icon /><span>Mes équipes</span>
        </router-link>
      </li>
      <li v-if="user!=null && isManager">
        <router-link
          class="navbar-item"
          :to="{ path: '/gestionnaire/societes'}"
        >
          <group-icon /><span>Gérer les domaines</span>
        </router-link>
      </li>
      <!-- END MANAGER ONLY -->
      <li v-if="user!=null && (isBusiness||isManager||isAdmin) && isOn===false">
        <router-link
          class="navbar-item"
          :to="{ path: '/support' }"
          target="_blank"
        >
          <help-icon /><span>Support</span>
        </router-link>
      </li>
      <!-- START IMPERSONATING ONLY -->
      <li v-if="isImpersonating">
        <a
          class="navbar-item"
          @click="exitImpersonate"
        >
          <ghost-icon class="ghost" /><span class="ghost">Quitter le mode observateur</span>
        </a>
      </li>
      <!--      href="http://dsnplus-saas/?_switch_user=_exit">-->
      <!-- END IMPERSONATING ONLY -->
      <li
        v-if="isOn===false && !isAdmin"
        role="separator"
        class="divider"
      />
      <li>
        <a
          class="navbar-item"
          href="#"
          @click="logoutAndRedirect()"
        >
          <i class="fa fa-sign-out fa-2x fa-fw" /><span>Se déconnecter</span>
        </a>
      </li>
    </ul>
  </div>
</template>

<script>
import {mapActions, mapGetters} from "vuex";
import SirenIcon from "../../components/Icon/SirenIcon";
import UploadIcon from "../../components/Icon/UploadIcon";
import UserIcon from "../../components/Icon/UserIcon";
import UsersIcon from "../../components/Icon/UsersIcon";
import GroupIcon from "../../components/Icon/GroupIcon";
import HelpIcon from "../../components/Icon/HelpIcon";
import PieIcon from "../../components/Icon/PieIcon";
import GhostIcon from "../Icon/GhostIcon";
import HomeIcon from "../Icon/HomeIcon";

export default {
  name: 'DropdownMenu',
  components: {HomeIcon, GhostIcon, PieIcon, HelpIcon, GroupIcon, UsersIcon, UserIcon, UploadIcon, SirenIcon},
  computed: {
    ...mapGetters([
      'user',
      'isBusiness',
      'isManager',
      'isAdmin',
      'isOn',
      'isImpersonating'
    ])
  },
  methods: {
    ...mapActions([
      'logout',
      'loadingStarts',
      'loadingEnds',
      'exitImpersonate'
    ]),
    logoutAndRedirect() {
      this.loadingStarts()
      this.logout()
        .then(()=> {
          this.$router.push({path: "/connexion"})
          this.loadingEnds()
          //bugs with bootstrap modal usage
          if($('.modal-backdrop')) {
            $('.modal-backdrop').remove()
          }
          if($('body').hasClass('modal-open')) {
            $('body').removeClass('modal-open')
          }
        });
    }
  }
}
</script>

<style scoped>
  .dropdown {
    padding-top: 10px;
    position: absolute;
    top: 0;
    right: 50px;
    z-index: 1;
    height: 42px;
    width: 42px;
    cursor: pointer;
    display: flex;
    align-items: center;
    justify-content: center;
    color: #4492d2;
  }
  @media (min-width: 768px) {
    .dropdown {
      right: 130px;
    }
  }
  a {
    background-color: #fff;
    color: #4492d2 !important;
  }

  i {
    font-size: 2em;
  }

  .dropdown-menu {
    left:-80px;
  }

  .ghost {
    color: #e65245;
  }
</style>